%%%%%%%%%%%%%%%%%%%%%% cp10_1.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/15/99 HS
%----------------------------------------------------
%   M-file for designing observer-controller for the 
%   	       power system example for 
%	     Comprehensive Problem CP10.1
%----------------------------------------------------
clear,clf
disp('Comprehensive Problem CP10.1')

epow

% transfer function from rectifier input to bus voltage
C = C(1,:); D = 0;
cflag = input('enter 1 to add more damping to system ==> ')
if cflag == 1
  A(2,2) = 10*A(2,2)
end

% find eigenvalues
lam = eig(A);

% assign full state feedback eigenvalues
lams = lam;
for i = 1:length(lams)
  if abs(lams(i)) < 1
    lams(i) = -2;
  end
end

disp('assign full-state-feedback eigenvalues at ')
lams

disp('full-state-feedback gain') 
K = place(A,B,lams)

% assign observer eigenvalues
lamo = lam;
for i = 1:length(lamo)
  if abs(lamo(i)) < 1
    lamo(i) = -4;
  end
end

disp('assign observer eigenvalues at ')
lamo

disp('observer gain')
L = place(A',C',lamo);
L = L'

disp('*****>');pause
A_f = A-B*K-L*C                        % controller system matrix
f_poles = eig(A_f)                     % controller poles
G_f = ss(A_f,-L,-K,0);
f_zeros = tzero(G_f)  		         	 % controller zeros
disp('*****>');pause
bode(G_f)                        		% frequency response plot
title('CP10.1: Frequency response of controller') 
keyboard
G = ss(A,B,C,D);
GK = G*G_f;
[AGK,BGK,CGK,DGK] = ssdata(GK);
margin(GK)
keyboard
G_cl = feedback(GK,1);
[Acl,Bcl,Ccl,Dcl]= ssdata(G_cl); 			% closed-loop system
cl_loop_poles = eig(Acl)               % closed-loop system poles
disp('*****>');pause
step(G_cl)
grid;title('CP10.1: Step response of closed loop system')
keyboard
disp('end of Comprehensive Example 10.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
