%%%%% fig10_4b.m %%%%% 
%	Jan. 99
%  last revision:  1/8/99  JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
  disp('fig 10.4b: Step response of observer-controller for Example 10.6')

  A = [-2 -2.5 -0.5; 1 0 0; 0 1 0];       % state matrix
  B = [ 1; 0; 0];                         % input matrix set to zero
  C = [1 4 3.5];                          % output matrix
  D = 0;                                  % throughput matrix
  Gp = ss(A,B,C,D)
  p_s = [-1 -2 -3];                       % desired system poles 
  F = place(A,B,p_s);                     % control gain
  p_o = [-3 -5 -7];                       % desired observer poles 
  L = place(A',C',p_o)';                  % estimator gain
  A_f = A-B*F-L*C ;                       % controller system matrix
  Gc = ss(A_f,-L,-F,0)
  %GcGp = Gc*Gp                           % cascade system
  GpGc = Gp*Gc                           % cascade system
  T = feedback(GpGc,1,-1)                % closed-loop system
  lfg = dcgain(T);
  N = 1/lfg;
  T_ref = N*T;
  t = [0:0.02:4]';
  step(T_ref,t);
  %  title('fig 10.4b: Step response of observer-controller for Example 10.6')
  plt_ttl('Step Response',' ')
  print -deps fig10_4b.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%