%%%%%%%%%%%%%%%%%%%%%% p10_12.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/15/99 HS
%----------------------------------------------------
%      Problem 10.12: observer-controller design 
%----------------------------------------------------
  clear,clf
  disp('Problem 10.12: observer-controller design')  
  disp('	3rd-order system')  
  disp(' ')
  A = [-4 1 2; 1 -5 3; 2 0 -6];           % state matrix
  B = [ 1; 0.5; 2];                       % input matrix
  C = [0 1 0];
  D = 0;                                  % throughput matrix
  G = ss(A,B,C,D)
  disp('*****>');pause
  p_s = [-4 -8 -10] 								% desired system poles
  F = place(A,B,p_s)                     % control gain
  disp('*****>');pause
  p_o = [-8 -16 -20]       		       % desired observer poles 
  L = place(A',C',p_o)'                  % estimator gain
  disp('*****>');pause
  A_f = A-B*F-L*C                        % controller system matrix
  f_poles = eig(A_f)                     % controller poles
  G_f = ss(A_f,-L,-F,0) 
  f_zeros = tzero(G_f)           		 % controller zeros
  bode(G_f)
  title('P10.12: System response')
  keyboard
  G_g = G*G_f;
  [Ag,Bg,Cg,Dg]= ssdata(G_g); 				% cascade system
  G_cl = feedback(G_g,1);
  [Acl,Bcl,Ccl,Dcl] = ssdata(G_cl)			 % closed-loop system
  cl_loop_poles = eig(Acl)               % closed-loop system poles
  disp('*****>');pause
  lfg = dcgain(G_cl)
  N = 1/lfg
  T_ref = N*G_cl;
  [AclN,BclN,CclN,DclN] = ssdata(T_ref)
  t = [0:0.01:2]';
  r = 0*t;
  z0 = [0 0 0 1 0.5 -0.25]'
  [x,y,z] = lsim(T_ref,r,t,z0);
  plot(t,z(:,1:3),t,z(:,4:6),'--'), grid
  title('P10.12: Initial condition response')
  keyboard
  step(T_ref,t)
  grid, title('P10.12: Step input response')
  keyboard  
  disp('end of Reinforcement Problem 10.12')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
