%%%%%%%%%%%%%%%%%%%%%% p10_5.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%----------------------------------------------------
%       Problem 10.5: Pole-placement design
% 	    High-gain and low-gain design
%----------------------------------------------------
  clear
  disp('Problem 10.5: Pole-placement design')
  disp('	Lightly-damped modes')  
  disp(' ')
  A = [-0.1 5 0.1; -5 -0.1 5; 0 0 10]  % state matrix
  B = [ 0; 0; 10]                    % input matrix
  disp('*****>');pause
  disp('Low-gain design')
  p = [-1+i*5 -1-i*5 -10]           % desired pole locations
  F = place(A,B,p)                  % control gain
  disp('magnitude of gain')
  nrmF = norm(F)
  disp('*****>');pause
  A_cl = A-B*F                      % closed-loop system matrix
  eig(A_cl)                         % check eigenvalues
  disp('*****>');pause
  disp('Extra-high-gain design')
  p = [-50 -60 -70]                 % desired pole locations
  F = place(A,B,p)                  % control gain
  disp('magnitude of gain')
  nrmF = norm(F)
  disp('*****>');pause
  A_cl = A-B*F                      % closed-loop system matrix
  eig(A_cl)                         % check eigenvalues
  disp('end of Reinforcement Problem 10.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%