%%%%%%%%%%%%%%%%%%%%%% cp2_1.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/23/99 HS
%----------------------------------------------------
%  .M file for analyzing the power system example for 
%           Comprehensive Problem CP2.1
%----------------------------------------------------
clear, clf
epow    % read data

disp('system zeros, poles, gain for Vterminal output')
G1 = tf(num1,den)
[z,p,k] = zpkdata(G1,'v')
disp('*****>'), pause

disp('system zeros, poles, gain for w(speed) output')
G2 = tf(num2,den)
[z,p,k] = zpkdata(G2,'v')
disp('*****>'), pause

disp('system zeros, poles, gain for Pe output')
G3 = tf(num3,den)
[z,p,k] = zpkdata(G3,'v')
disp('*****>'), pause

disp('partial fraction expansion of Vterminal output')
[r,p,k] = residue(num1,den)
disp('*****>'), pause

disp('partial fraction expansion of w(speed) output')
[r,p,k] = residue(num2,den)
disp('*****>'), pause

disp('partial fraction expansion of Pe output')
[r,p,k] = residue(num3,den)
disp('*****>'), pause

disp('Step reponse of Vterminal')
step(G1)
grid;title('CP2.1: Step reponse of Vterminal')
disp('dcgain is ')
dcgain(G1)
keyboard

disp('Step reponse of w(speed)')
step(G2)
grid;title('CP2.1: Step reponse of w(speed)')
disp('dcgain is ')
dcgain(G2)
keyboard
disp('replotting to see oscillation')
axis([0 5 -1e-3 0])
keyboard

disp('Step reponse of Pe')
step(G3)
grid;title('CP2.1: Step reponse of Pe')
disp('dcgain is ')
dcgain(G3)
disp('end of Comprehensive Problem 2.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
