%%%%%%%%%%%%%%%%%%%%%% p2_8.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%              last revision: 5/25/99 HS
%----------------------------------------------------
% Problem 2.8: find zeros, poles, gain of a tf model,
%        and perform PFE and impulse response
% Also does responses due to real and complex poles
%    		separately:  ytot = ycplx + yreal
%   Uses special functions rpole2t & cpole2t
%----------------------------------------------------
clear, clf
disp('Problem 2.8: Fourth-order system with')
disp('             responses due to individual poles')
numG =[3 4 5]
denG = [2 7 11 12 4]
G = tf(numG,denG)
disp('*****>');pause
GG = zpk(G)
disp('*****>');pause
[zG,pG,kG] = zpkdata(G,'v')
disp('*****>');pause
[resG,polG,otherG] = residue(numG,denG)
disp('*****>');pause
t = [0:0.05:10]';
%%%-- response due to real and complex poles
ycmplx = cpole2t(polG(2),resG(2),t);
yreal = rpole2t(polG(1),resG(1),t)...
	+ rpole2t(polG(4),resG(4),t);
ytot = ycmplx + yreal;
plot(t,ytot,t,ycmplx,t,yreal,'--');grid
title('P2.8: Impulse Response from Individual Poles')
text(1.7,0.4,'total')
text(0.8,0.0,'complex')
text(0.8,-0.035,'poles')
text(3.35,0.15,'2 real poles')
keyboard
yy = impulse(numG,denG,t);
plot(t,ytot,t,yy);grid
title('P2.8: Impulse Response from G(s)')
disp('End of Reinforcement Problem 2.8')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
