%%%%%%%%%%%%%%%%%%%%%% ch3ex.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, Nov. 94
%----------------------------------------------------
%  This MATLAB file runs the exercises that appear 
%  in Chapter 3 (Transfer Function Models) in the 
%  BookWare Companion Feedback Control Problems Using 
%  MATLAB by D. K. Frederick and J. H. Chow 
%----------------------------------------------------
clear,clf
disp('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
disp('When you see the prompt "******>" the program is at a PAUSE')
disp('Hit the ENTER/RETURN key to continue')
disp(' ')
disp('When you see the prompt K>> the keyboard is active')
disp('so you are able to print the plot that was on the screen')
disp('display any of the variables, or enter other commands.')
disp('To continue enter the command "return"')
disp('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
disp('   ')
%
%  menu to select Example to be run
example = -1;	% force menu to appear
while (example < 0) | (example > 5),
  disp(' 1 <= Example 3.1: Series connection of two systems')
  disp(' 2 <= Example 3.2: Parallel interconnection')
  disp(' 3 <= Example 3.3: Series/Parallel interconnection')
  disp(' 4 <= Example 3.4: Feedback interconnection')
  disp(' 5 <= Example 3.5: 2-input feedback system')
  example = input('Select an example, or enter 0 to quit ==> ');

if example == 0, disp('Completed Chapter 3 examples'), return, end

if example == 1,
  disp('Example 3.1')
  disp('------------------')
  disp('   Build series connection of G1(s) and G2(s)')
  disp('------------------')
  disp('>>> G1(s) in TF form')
  G1 = tf([2 3],[5 2 2])
  disp('*******>');pause
  disp('>>> G2(s) in ZP form')
  G2 = zpk(-2,[-0.5; -8],5)
  disp('*******>');pause
  disp('>>> series combination G12(s) in ZP form')
  G12ZP = G2*G1
  disp('*******>');pause
  disp('>>> series combination G12(s) in TF form')
  G12TF = tf(G12ZP)
  disp('*******>');pause
  disp('>>> compute and plot the step response of G12(s)')
  step(G12ZP), hold on
  step(G12TF), hold off
  grid;%title('Ex 3.1: step response of series combination')
  % student - put pause in between plots, and use 'o' to second plot
  disp('*******>');pause
  disp('>>> zeros, poles, & gain of G1(s)')
  [zG1,pG1,kG1] = zpkdata(G1,'v')
  disp('*******>');pause
  disp('>>> zeros, poles, & gain of G12ZP(s)')
  [zG12,pG12,kG12] = zpkdata(G12ZP,'v')
keyboard
  clear G1 G2 G12TF G12ZP numG2 denG2 zG1 pG1 kG1 
  clear zG12 pG12 kG12
  disp('end of Example 3.1')
  example = -1;	% force menu to appear
end	% of Example 3.1 so return to menu
%-------------------------------------

if example == 2,
  disp('Example 3.2: ')
  disp('-----------------')
  disp('Build T(s), a parallel connection of H1(s) and H2(s)')
  disp('then find the zeros, poles, gain of T(s)')
  disp('finally, plot step response')
  disp('-----------------')
disp('>>> H1(s) in TF form')
H1 = tf([2 6],[1 1 8])
disp('*******>');pause
disp('>>> H2(s) in TF form')
denH2 = conv([1 1],[1 4 1]);
H2 = tf([1 4],denH2)
disp('*******>');pause
disp('>>> T(s) in TF form')
T = H1 + H2
disp('*******>');pause
disp('>>> zeros, poles, and gain of T(s)')
[zT,pT,kT] = zpkdata(T,'v')
disp('*******>');pause
disp('>>> poles of H1(s)')
pH1 = pole(H1)     % poles of H1
disp('>>> poles of H2(s)')
pH2 = pole(H2)     % poles of H2
disp('*******>');pause
disp('>>> compute and plot step reponse of T(s)')
step(T)
grid;%title('Ex 3.2: step response of parallel connection')
  keyboard
  clear H1 pH1 denH2 H2 pH2 T
  clear zT pT kT
  disp('end of Example 3.2')
  example = -1;	% force menu to appear
end	% of Example 3.2 so return to menu
%-------------------------------------

if example == 3,
  disp('Example 3.3: ')
  disp('-----------------')
  disp('Build T(s) as a series/parallel connection of of 4 blocks')
  disp('then find the zeros, poles, gain of T(s)')
  disp('finally, plot step response')
  disp('-----------------')
  disp('>>> G1(s) of Ex. 3.1 in TF form')
  G1 = tf([2 3],[5 2 2])
  disp('*******>');pause
  disp('>>> G2(s)) of Ex. 3.1 in ZPK form')
  G2 = zpk(-2,[-0.5; -8],5)
  disp('*******>');pause
  disp('>>> G3(s) in TF form [H1(s) of Ex. 3.2]')
  G3 = tf([2 6],[1 1 8])
  disp('*******>');pause
  disp('>>> G4(s) in TF form [H2(s) of Ex. 3.2]')
  G4 = tf([1 4],conv([1 1],[1 4 1]))
  disp('*******>');pause
  disp('>>> series/parallel connection of G1, G2, G3 & G4')
  T = G4*(G3 + G2*G1)
  disp('*******>');pause
  disp('>>> Convert T(s) to TF form')
  Ttf = tf(T)
  disp('*******>');pause
  disp('>>> DC gain and poles of T(s)')
  pT = pole(T)
  TgainDC = dcgain(T)
  disp('*******>');pause
  disp('>>> compute and plot step reponse of T(s)')
  step(T)
  grid;%title('Ex 3.3: step response of series/parallel connection')
  keyboard
  clear G1 G2 G3 G4 T pT TgainDC
  disp('end of Example 3.3')
  example = -1;	% force menu to appear
end	% of Example 3.3 so return to menu
%-------------------------------------
if example == 4,
  disp('Example 3.4:')
  disp('----------------------------')
  disp('Build T(s) as feedback connection of G(s) and H(s)')
  disp(' then find zeros, poles, & gain of T(s)')
  disp('finally, compute and plot step response')
  disp('----------------------------')
  disp('>>> forward transfer function G(s) in TF form and its poles')
  G = tf([4 1],[5 3 2])
  pG = pole(G)   % poles of G(s)
  disp('*******>');pause
  disp('>>> feedback transfer function H(s) in TF form and its poles')
  H = tf([1 6],[1 4 11])
  pH = pole(H)    % poles of H(s)
  disp('*******>');pause
  disp('>>> T(s) in TF form')
  T = feedback(G,H)
  %disp('*******>');pause
  %disp('>>> T(s) in TF form formula')
  %T = G/(1+G*H); - student - need minreal realization to reduce 
  %							redundent poles and zeros. 
  disp('*******>');pause
  disp('>>> zeros, poles, & gain of feedback transfer function T(s)')
  [zT,pT,kT] = zpkdata(T,'v')
  disp('*******>');pause
  disp('>>> step response of feedback transfer function T(s)')
  step(T)
  grid;%title('Ex 3.4: step response of feedback connection')
  keyboard
  clear numG denG pG numH denH pH numT denT zT pT kT
  disp('end of Example 3.4')
  example = -1;	% force menu to appear
end	% of Example 3.4 so return to menu
%-------------------------------------
if example == 5,
  disp('Example 3.5:')
  disp('----------------------------')
  disp('Build TR(s) & TD(s) as feedback connections')
  disp('   with reference & disturbance inputs, respectively')
  disp('Find open- & closed-loop zeros, poles, & gain of each system')
  disp('Compute and plot step responses')
  disp('----------------------------')
%
  disp('lead controller transfer function Gc(s) in TF form')
  Gc = tf(80*[1 3],[1 15*3])
  disp('*******>');pause
  disp('plant transfer function Gp(s) in TF form')
  Gp = tf(4,conv([0.5 1],[2 1]))	
  disp('*******>');pause
  disp('sensor transfer function H(s) in TF form')
  H = tf(1,[0.05 1])
  disp('*******>');pause
  %------ reference closed-loop transfer function
  T_ref = feedback(Gp*Gc,H)
  disp('*******>');pause
  disp(' closed-loop zeros & poles for reference input & DC gain')
  [zT_ref,pT_ref,kT_ref] = zpkdata(T_ref,'v')
  T_ref_gainDC = dcgain(T_ref)
  disp('*******>');pause
  t = [0:0.01:2];
  y_ref = step(T_ref,t);
  %------ repeat for disturbance closed-loop transfer function
  T_dist = feedback(Gp,Gc*H)
  disp('*******>');pause
  disp(' closed-loop zeros & poles for disturbance input & DC gain')
  [zT_dist,pT_dist,kT_dist] = zpkdata(T_dist,'v')
  T_dist_gainDC = dcgain(T_dist)
  disp('*******>');pause
  t = [0:0.01:2];
  y_dist = step(T_dist,t);
  %-------- plot both responses
  plot(t,y_ref,t,y_dist,'--')
  xlabel('Time (s)'),ylabel('output')
  grid;
  title('Ex 3.5: CL ref & dist step responses,lead control')
  text(1.0,1.00,'reference input')
  text(1.0,0.22,'disturbance input')
  keyboard
  disp('end of Example 3.5')
  example = -1;	% force menu to appear
end	% of Example 3.5 so return to menu
%-------------------------------------
end		% of while
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
