%%%%%%%%%%%%%%%%%%%%%% cp3_2a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/25/99 HS
%----------------------------------------------------
%            Comprehensive Problem CP3.2a
%     Satellite with proportional-only control,
%	        does ref step response
%----------------------------------------------------
disp('CP3.2A: Satellite with proportional-only control')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1; 
    load sat.mat
  else
    return
end
%
numGp = numG1;	% plant model in TF form for tau_m --> theta
denGp = denG1;
Gp = tf(numGp,denGp)
disp('A reasonable value is Kp = -0.001')
Kp = input('enter lead gain (<0) ==>')
Kp_str = num2str(Kp);	
%------ use Eq 3.3 for lead TF
numGc = Kp;
denGc = 1;
Gc = tf(numGc,denGc)
%------- forward transfer function is Gc * Gp
G_OL = Gc*Gp
%---- closed-loop TF with H(s) = 1
G_CL = feedback(G_OL,1)
disp('closed-loop zeros, poles & DC gain are:')
[zCL,pCL,kCL]=zpkdata(G_CL,'v')
disp('*******>');pause
%---- run for 1000 sec
t = [0:2:1000]';
y = step(G_CL,t);
plot(t,y);grid
xlabel('Time (secs)'); ylabel('Pointing angle (deg)')
title('CP3.2a: satellite with P-only, step in theta_des')
text('Units','Norm','Pos',[0.6 0.25],'String',...
			['Kp = ' Kp_str])
disp('end of Comprehensive Problem 3.2a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%