%%%%%%%%%%%%%%%%%%%%%% cp3_3b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%          Comprehensive Problem CP3.3b
%            Satellite with lead-lag, 
%	     does disturbance impulse response
%----------------------------------------------------
disp('CP3.3B: Satellite with lead-lag')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
disp('A reasonable value is Kldlg = -0.001')
Kldlg = input('enter controller gain (<0) ==>')
Kldlg_str = num2str(Kldlg);
disp('A reasonable value is Zlead = -0.02')
Zlead = input('enter lead zero (<0) ==>')
Zlead_str = num2str(Zlead);
disp('A reasonable value is Zlag = -0.002')
Zlag = input('enter lag zero (<Zlead) ==>')
Zlag_str = num2str(Zlag);
disp('A reasonable value is alpha = 20')
Alpha = input('enter lead alpha ==>')
Alpha_str = num2str(Alpha);	
%------ use Eq 3.3 for lead TF
G1 = tf(numG1,denG1)
G3 = tf(numG3,denG3)
numGc = Kldlg*conv([1  -Zlag],[1 -Zlead]);
denGc = conv([1 -Zlag/Alpha],[1  -Alpha*Zlead]);
Gc = tf(numGc,denGc)
%---- feedback loop has G(s) = 1 & H(s) = - Gc * G1
H  = -Gc*G1
disp('zeros, poles & DC gain of H(s) are:')
[zH,pH,kH]=zpkdata(H,'v')
disp('*******>');pause
%---- closed-loop TF with G(s) = 1 & pos fdbk
H_CL = feedback(1,H,+1)
disp('closed-loop zeros, poles & DC gain are:')
[zCL,pCL,kCL]=zpkdata(H_CL,'v')
disp('*******>');pause
%---- make series connection
T = G3*H_CL
disp('zeros, poles & DC gain from tau_dist --> theta are:')
[zT,pT,kT]=zpkdata(T,'v')
disp('*******>');pause
%--- now do impulse response for 4000 sec
t = [0:10:4000]';
y = 0.002*impulse(T,t);
plot(t,y);grid
xlabel('Time (secs)'); ylabel('Pointing angle (deg)')
title...
 ('CP3.3b: satellite with lead-lag, dist torque impulse of 0.002N-m-s')
text('Units','Norm','Pos',[0.6 0.85],'String',...
			['Kldlg = ' Kldlg_str])
text('Units','Norm','Pos',[0.6 0.75],'String',...
			['Zlag = ' Zlag_str])
text('Units','Norm','Pos',[0.6 0.65],'String',...
			['Zlead = ' Zlead_str])
text('Units','Norm','Pos',[0.6 0.55],'String',...
			['Alpha = ' Alpha_str])
disp('end of Comprehensive Problem 3.3b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%