%%%%%%%%%%%%%%%%%%%%% wif3_4.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, Chow, May 1999
%             last revision: 5/24/99 HS
%----------------------------------------------------
%	        What If for Example 3.4:
%	 Parallel connection with subtraction
%----------------------------------------------------
clear,clf
  disp('WhatIf? 3.4: ')
  disp('----------------------------')
  disp('Feedback connection of G(s) and H(s)')
  disp('with gain of G(s) varied')
  disp('----------------------------')
kG = input('Enter gain (1.0 - same as Example 3.4  ==>');
  disp('>>> forward transfer function G(s) and its poles')
  numG = kG*[4 1]
  denG = [5 3 2]
  G = tf(numG,denG)
  pG = roots(denG)   % poles of G(s)
  disp('*******>');pause
  disp('>>> feedback transfer function H(s) and its poles')
  numH = [1 6]
  denH = [1 4 11]
  H = tf(numH,denH)
  pH = roots(denH)    % poles of H(s)
  disp('*******>');pause
  disp('>>> numerator & denominator of feedback transfer function T(s)')
  T = feedback(G,H)
  disp('*******>');pause
  disp('>>> zeros, poles, & gain of feedback transfer function T(s)')
  [zT,pT,kT] = zpkdata(T,'v')
  disp('*******>');pause
  disp('>>> step response of feedback transfer function T(s)')
  step(T)
  grid;title('WIF3.4: step response of feedback connection')
  text('Units','norm','Pos',[0.5 0.1],...
			'Str',['loop gain added = ' num2str(kG)])
disp('end of What If 3.4')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
