%%%%%%%%%%%%%%%%%%%%%% cp5_4a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system 
%      example for Comprehensive Problem CP5.4a
%----------------------------------------------------
clear, clf
disp('Comprehensive Problem 5.4a')
disp('Root-locus analysis of proportional control ')
disp('...of hydro-turbine system')

hydro  % read data
disp('*****>'), pause

disp('Run root-locus')
G = tf(numG,denG)
rlocus(G)
grid
axis([-3 3 -3 3])
axis('equal')
title('CP5.4a: Root-locus plot')

disp('use pointer to click on imaginary-axis crossing ')
disp('...in graphics window to find Kp*')
[k,p] = rlocfind(G)
disp('The gain to marginal stability should be the same as that')
disp('...found from CP 3.5a')
keyboard

disp('Closed-loop system transfer functin for ')
disp('...proportional control Kp = 0.5')
T = feedback(0.5*G,1)
disp('*****>'), pause

disp('Poles of closed-loop system')
pole(T)
disp('Zeros of closed-loop system')
tzero(T)
disp('DC gain of closed-loop system')
dcgain(T)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP5.4a: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('end of Comprehensive Problem 5.4a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
