%%%%%%%%%%%%%%%%%%%%%% cp5_4b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system 
%      example for Comprehensive Problem CP5.4b
%----------------------------------------------------
clear,clf
disp('Comprehensive Problem 5.4b')
disp('Root-locus analysis of lead controller ')
disp('...of hydro-turbine system')

hydro  % read data
disp('*****>'), pause

disp(' ')
disp('Lead controller with zero at s = -3 and alpha = 20')
G = tf(numG,denG)
z = -3
numlead = [1  -z];
denlead = [1  -20*z];
Glead = tf(numlead,denlead)
G_OL = Glead*G;
disp('*****>'), pause

disp('Run root-locus')
rlocus(G_OL)
grid
axis([-8 8 -8 8])
title('CP5.4b: Root-locus plot')

disp('use pointer to select a closed-loop poles')
[k,p] = rlocfind(G_OL)
keyboard

disp('Closed-loop system transfer functin for ')
disp('...the gain value selected')
T = feedback(k*G_OL,1)
disp('*****>'), pause

disp('Poles of closed-loop system')
pole(T)
disp('Zeros of closed-loop system')
tzero(T)
disp('DC gain of closed-loop system')
dcgain(T)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP5.4b: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('Repeat the root-locus analysis with lead zero at s = -1 ')
disp('Lead controller with zero at s = -1 and alpha = 20')
z = -1
numlead = [1  -z];
denlead = [1  -20*z];
Glead = tf(numlead,denlead)
G_OL = Glead*G;
disp('*****>'), pause

disp('Run root-locus')
rlocus(G_OL)
grid
axis([-8 8 -8 8])
axis('equal')
title('CP5.4b: Root-locus plot')

disp('use pointer to select a closed-loop pole')
[k,p] = rlocfind(G_OL)
keyboard

disp('Closed-loop system transfer functin for ')
disp('...the gain value selected')
T = feedback(k*G_OL,1)
disp('*****>'), pause

disp('Poles of closed-loop system')
pole(T)
disp('Zeros of closed-loop system')
tzero(T)
disp('DC gain of closed-loop system')
dcgain(T)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP5.4b: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('end of Comprehensive Problem 5.4b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
