%%%%% fig6_3.m %%%%% 
%	Dec 98
% last revision: 12/28/1998, JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 6.3: Example 6.3 - Break frequencies and asymptotes')
  numG = [ 1280 640 ]
  denG = [ 1 24.2 1604.81 320.24 16 ]
  G = tf(numG,denG)
  Gzp = zpk(G)
  w = logspace(-2,3,100)';  
  [mag,phase] = bode(G,w);
  mag = reshape(mag,[100 1]);  % reshape a 1x1x100 matrix into a 
  										 % 100x1 matrix
  semilogx(w,20*log10(mag),'--')  
  hold on
  lfg = dcgain(G);
  cf1_dB = 20*log10(lfg);
  plot([0.01; 0.1],[cf1_dB; cf1_dB],'-')
  cf2_dB = cf1_dB - 40*log10(0.5/0.1);
  plot([0.1; 0.5],[cf1_dB; cf2_dB],'-')
  cf3_dB = cf2_dB - 20*log10(40/0.5);
  plot([0.5; 40],[cf2_dB; cf3_dB],'-')
  end_dB = cf3_dB - 60*log10(1000/40);
  plot([40;1000],[cf3_dB; end_dB],'-')
  hold off 
  % labels for asymptotes
  text(0.23,25,'-40 dB/dec')
  text(1.5,-25,'-20 dB/dec')
  text(15,-70,'-60 dB/dec')
  axis([0.01 1000 -100 40])
  xlabel('Frequency (rad/sec)')
  ylabel('Gain dB')
  %title('fig 6.3: Break frequencies and asymptotes')
  grid
  print -deps fig6_3.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%