%%%%%%%%%%%%%%%%%%%%% wif6_2a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  Example 6.2 (Frequency Response Plot) 
%----------------------------------------------------
clear,clf
  disp('What-if problem Part (a) following ')
  disp('Example 6.2: Bode, Nichols and Nyquist plots')
  disp(' ')
  disp('Enter transfer function coefficients')
  numG = [ 1280 640 ]
  denG = [ 1 24.2 1604.81 320.24 16 ]
  G = tf(numG,denG)
  numGo = numG
  disp('*****>');pause
  K = [0.1 2 10];
  for i = 1:3
    disp('Gain value K = ')
    K(i)  
    numG = K(i)*numGo
    disp('Make Bode plot directly from the bode command')
    w = logspace(-2,3,100)';  
    bode(G,w);
    title('WIF6.2a : Bode plot ')
    keyboard
    disp('Make Nichols plot directly from the nichols command')
    disp('  The encirclement direction is indicated')
    subplot(1,1,1), nichols(G,w), grid
    ngrid
    title('WIF6.2a : Nichols plot')
    hold on
    plot([-180 -180],[-400 400])  % make solid line for axis
    plot([-1000 1000],[0 0])
    hold off
    axis([-270 0 -100 40])
    keyboard
    disp('Make Nyquist plot directly from the nyquist command')
    nyquist(G);
    grid, title('WIF6.2a : Nyquist plot')
    keyboard
    disp('Another Nyquist plot showing the detail about the -1 point.')
    disp('  We will put a unit circle about the origin on the plot.')
    axis([-1 1 -1 1])
    hold on
    %  make unit circle
    sgrid([ ],[ 1 -1 ])
    keyboard
    hold off
    axis('normal')
    axis('auto')
  end
  disp('end of What If 6.2a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
