%%%%%%%%%%%%%%%%%%%%%% cp7_2a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%      Solution to comprehensive problem 7.2a
%  Time-domain performance measures for the satellite
%----------------------------------------------------
clear, clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
numGp = numG1; denGp = denG1; % rename TF for plant
Gp = tf(numGp,denGp)
%----- add a lead in series, set alpha = 10
disp('You can use Klead = -0.002 and Zlead = -0.01 if ')
disp('.....you wish. Then try some values of your own.')
Klead = input('enter Klead ==> ');
Zlead = input('enter lead zero (<0) ==> ')
K_str = num2str(Klead);
Z_str = num2str(Zlead);
disp('lead transfer function')
numGc = Klead*[1  -Zlead]
denGc = [1  -10*Zlead]
Gc = tf(numGc,denGc)
disp('********>');pause
disp('TF of series combination of lead + plant')
G = Gc*Gp
disp('********>');pause
disp('closed-loop TF')
Tr = feedback(G,1)
disp('********>');pause
t = [0:2:600]';	% simulate for 10 minutes
y = step(Tr,t);
plot(t,y); grid
ylabel('amplitude');xlabel('Time (sec)')
title('CP7_2a: Step response of satellite + lead')
text('Units','Norm','Pos',[0.7 0.25],'String',...
				['Klead = ' K_str])
text('Units','Norm','Pos',[0.7 0.20],'String',...
				['Zlead = ' Z_str])
[pos,tp,tr,ts,ess] = tstats(t,y,1.0);
text('Units','Norm','Pos',[0.1 0.25],'String',...
		['overshoot = ' num2str(pos) ' %'])
text('Units','Norm','Pos',[0.1 0.20],'String',...
		['peak time = ' num2str(tp)])
text('Units','Norm','Pos',[0.1 0.15],'String',...
		['rise time = ' num2str(tr)])
text('Units','Norm','Pos',[0.1 0.10],'String',...
		['2pct settling time = ' num2str(ts)])
text('Units','Norm','Pos',[0.1 0.05],'String',...
		['steady-state error = ' num2str(ess) ' %'])
keyboard
damp(Tr)	% CL poles with damping ratios
disp('********>');pause
[Mo,tp,tr,ts,ess] = tstats(t,y,1.0)
disp('end of Comprehensive Problem 7.2a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
