%%%%%%%%%%%%%%%%%%%%%% cp7_2b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%      Solution to comprehensive problem 7.2b
%	   the satellite gain & vel constants
%----------------------------------------------------
clear, clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
numGp = numG1; denGp = denG1; % rename TF for plant
Gp = tf(numGp,denGp)
%----- add a lead in series, set alpha = 10
disp('You can use Klead = -0.002 and Zlead = -0.01 if ')
disp('.....you wish. Then try some values of your own.')
Klead = input('enter Klead ==> ');
Zlead = input('enter lead zero (<0) ==> ')
K_str = num2str(Klead);
Z_str = num2str(Zlead);
disp('lead transfer function')
numGc = Klead*[1  -Zlead]
denGc = [1  -10*Zlead]
Gc = tf(numGc,denGc)
disp('********>');pause
disp('TF of series combination of lead + plant')
Gcp = Gc*Gp
[numGcp,denGcp] = tfdata(Gcp,'v')
disp('********>');pause
%--- cancel zero & pole at s = 0
num = deconv(numGcp,[1 0])
den = deconv(denGcp,[1 0])
G = tf(num,den)
%----- calculate position constant
Kp = dcgain(G) 
disp('Position constant is infinite ==> NOT type-0')
disp('********>');pause
%--- calculate velocity constant
Kv = vgain(G)
disp('Velocity constant is > 0 & finite ==> type-1')
disp('********>');pause
T = feedback(G,1)
t = [0:2:600]';	% simulate for 10 minutes
u = t;		% ramp input with slope = 1
y = lsim(T,u,t);
plot(t,[t y]);grid
title('CP7.2b: Ramp response')
xlabel('time in seconds')
ylabel('response')
text('Units','Norm','Pos',[0.7 0.25],'String',...
				['Klead = ' K_str])
text('Units','Norm','Pos',[0.7 0.20],'String',...
				['Zlead = ' Z_str])
disp('end of Comprehensive Problem 7.2b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
