%%%%%%%%%%%%%%%%%%%%%% cp7_2c.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%	 Solution to comprehensive problem 7.2c
%    Frequency-domain performance measures for the 
%                     satellite
%----------------------------------------------------
clear, clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
numGp = numG1; denGp = denG1; % rename TF for plant
Gp = tf(numGp,denGp)
%----- add a lead in series, set alpha = 10
disp('You can use Klead = -0.001 and Zlead = -0.02 if ')
disp('.....you wish. Then try some values of your own.')
Klead = input('enter Klead ==> ');
Zlead = input('enter lead zero (<0) ==> ')
K_str = num2str(Klead);
Z_str = num2str(Zlead);
numGc = Klead*[1  -Zlead]
denGc = [1  -10*Zlead]
Gc = tf(numGc,denGc)
disp('TF of series combination of lead + plant')
Gcp = Gc*Gp
[numGcp,denGcp] = tfdata(Gcp,'v')
disp('********>');pause
%--- cancel zero & pole at s = 0
num = deconv(numGcp,[1 0])
den = deconv(denGcp,[1 0])
G = tf(num,den)
disp('********>');pause
T = feedback(G,1)
disp('********>');pause
margin(G)
text('Units','Norm','Pos',[0.7 0.30],'String',...
				['Klead = ' K_str])
text('Units','Norm','Pos',[0.7 0.20],'String',...
				['Zlead = ' Z_str])
keyboard
bode(T)
title('CP7.2c: CL frequency response')
text('Units','Norm','Pos',[0.1 0.30],'String',...
				['Klead = ' K_str])
text('Units','Norm','Pos',[0.1 0.20],'String',...
				['Zlead = ' Z_str])
keyboard
[magCL,phCL,w] = bode(T);  			 % CL frequency response
magCLdB = 20*log10(magCL);           % gain in dB
lfgCL = dcgain(T)          			 % dc gain
BW = bwcalc(magCLdB,w,lfgCL)         % bandwidth
[Mpw,i] = max(magCLdB);              % maximum freq. resp.
wr = w(i)                            % freq of max response    
disp('*****>');pause
disp('do sensitivity function')
S = feedback(1,G) 
bode(S)                            % sensitivity
title('CP7.2c: sensitivity function frequency response')
text('Units','Norm','Pos',[0.1 0.30],'String',...
				['Klead = ' K_str])
text('Units','Norm','Pos',[0.1 0.20],'String',...
				['Zlead = ' Z_str])
keyboard
disp('end of Comprehensive Problem 7.2c')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

