%%%%%%%%%%%%%%%%%%%%%% p7_2.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%     Problem 7.2: simulate step response to find
%       overshoot, rise time, settling time, and 
%               steady-state error
%----------------------------------------------------
clear,clf
  disp('Problem 7.2: find system step-response performance')
  disp('overshoot, rise time, settling time, & steady-state error')  
  disp(' ')
  denGp = conv(conv([1 0],[1 1]),[1 20])
  Gp = tf(1,denGp)
  numGc = 500*[1 0.5], denGc = [1 5]
  Gc = tf(numGc,denGc)
  Gcp = Gc*Gp
  disp('*****>');pause
  Tr = feedback(Gcp,1)
  t = [0:0.05:20]';
  y = step(Tr,t);
  clf, plot(t,y); grid
  ylabel('amplitude');xlabel('Time (sec)')
  title('P7.2: Step response of third order system with lag controller')
  [mo,tp,tr,ts,ess] = tstats(t,y,1.0);
  text(2,0.30,['overshoot = ' num2str(mo) ' %'])
  text(2,0.25,['time to overshoot = ' num2str(tp) ' s'])
  text(2,0.20,['rise time = ' num2str(tr) ' s'])
  text(2,0.15,['2% settling time = ' num2str(ts) ' s'])
  text(2,0.10,['steady-state error = ' num2str(ess) ' %'])
  damp(Tr)
  [numTr,denTr] = tfdata(Tr,'v')
  [resS,polS,otherS] = residue(numTr,[denTr 0])
  keyboard
  Td = feedback(Gp,Gc)
  step(Td,t)
  grid
  title('P7.2: Disturbance response of system with lag controller')
  keyboard
  disp('end of Reinforcement Problem 7.2')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%