%%%%%%%%%%%%%%%%%%%%% wif7_3.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  Example 7.3 (Frequency-Response Performance)
%----------------------------------------------------
clear,clf
  disp('What-if following ')
  disp('Example 7.3: Bandwidth, gain & phase margins')
  disp(' ')
  denGp = conv(conv([1 0.01],[1 1]),[1 20])
  Gp = tf(1,denGp)
  disp('*****>');pause
  G = 100*Gp
  margin(G)             				       % gain & phase margins
  disp('Margins are smaller with higher proportional gain')
  keyboard
  T = feedback(G,1)
  bode(T)
  title('WIF7.3: transfer function frequency response')
  keyboard
  [mag_CL,ph_CL,w] = bode(T);  		  		 % frequency response
  mag_CLdB = 20*log10(mag_CL);             % gain in dB
  lfg_CL = dcgain(T)           				 % dc gain
  lfg_CL_dB = 20*log10(lfg_CL);
  BW = bwcalc(mag_CLdB,w,lfg_CL)           % bandwidth
  [M_pw,i] = max(mag_CLdB)                 % maximum freq. resp.
  wp = w(i)
  disp('With a higer proportional gain, the closed-loop bandwidth')
  disp('... and the resonance peak are higher.')                                
  disp('*****>');pause
  clf;
  S = feedback(1,G) % S(s)
  [magS,phS] = bode(S,w);                    % sensitivity
  magS_dB = 20*log10(magS);
  [maxS,j] = max(magS_dB)							% maximum sensitivity magnitude
  w(j)
  semilogx(w,mag_CLdB(:),'-',w,magS_dB(:),'--'), grid
  xlabel('Frequency (rad/sec)')
  ylabel('Gain dB')
  text(20,5,'|T(jw)|')
  text(20,-40,'|S(jw)|')
  title('WIF7.3: Plot of the Magnitude of T(jw) and S(jw)') 
  disp('end of What If 7.3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
