%%%%%%%%%%%%%%%% fig8_4.m %%%%%%%%%%%%%%%
%
%      2nd order plant with 2 real poles with PI control
% 	draws figure 8.4
%  	Jan 99
%   last revision:  1/6/99  JHC
%----------------------------------------
clear; 
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 8.4: Prop + integral control')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
Gp    = tf(Kproc,denGp)
H     = tf(1,[tau_sen 1])
KP = 1.0;
KI = 0.5;	% selected based on 2% settling time
KI_str=num2str(KI);
Kc = tf(KP*[1 KI],[1 0]);
rlocus(Kc*Gp*H)
set(findobj('marker','o'),'markersize',10)
set(findobj('marker','x'),'markersize',10)
grid
axis equal
% title('fig 8.4: open-loop, PI control for Ex 8.2')
text(-6.0,1.0,['KI = ' KI_str])
axis([-8 2 -2 8])
%------mark for gains
%text(0.0,6.31,'+')
text(-0.1,6.31,'+')
text(-1.25,6.31,'10.95')

%text(-0.56,4.02,'+')
text(-0.66,4.02,'+')
text(-1.60,4.03,'4.30')

%text(-0.87,1.99,'+')
text(-0.97,1.99,'+')
text(-1.90,1.99,'1.20')

%text(-0.95,1.00,'+')
text(-1.05,1.00,'+')
text(-2.00,1.00,'0.47')

%text(-1.00,0.00,'+')
text(-1.10,0.00,'+')
text(-2.0,-0.40,'0.24')
print -deps fig8_4.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%