%%%%%%%%%%%%%%%% fig9_2.m %%%%%%%%%%%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
clear;clf
disp('Fig 9.2: initial Bode plot for Ex. 9.1')
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4; 
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]));
H  = tf(1,[tau_sen 1]);
%---------- open-loop transfer function
GpH = Gp*H;
w = logspace(-1,1,100);
ph180 = -180*ones(length(w));
[mag,ph] = bode(GpH,w);
mag = reshape(mag,1,100);
ph  = reshape(ph, 1,100);
mag_db = 20*log10(mag);
subplot(211)
semilogx(w,mag_db);grid;
xlabel('Frequency (rad/sec)')
ylabel('Gain dB')
%title('fig 9.2: initial OL freq resp for Example 9.1')
hold on
x1 = [1.42 1.42];y1 = [-15 15];
x2 = [0.80 2.5]; y2 = [0.693 0.693];
line(x1,y1)
line(x2,y2)
text(0.15,0.0,'1.083 = 0.693 dB')
text(1.00,-25,'1.42 rad/s')
hold off
subplot(212)	%---- phase plot
semilogx(w,ph);grid
xlabel('Frequency (rad/sec)')
ylabel('Phase deg')
hold on
semilogx(w,ph180,'--')
x3 = [1.42 1.42]; y3 = [-160 -50];
x4 = [0.80 2.5]; y4 = [-110 -110];
line(x3,y3)
line(x4,y4)
text(1.00,-35,'1.42 rad/s')
text(0.30,-110,'-110 deg')
text(0.12,-165,'-180 deg')
hold off
print -deps fig9_2.eps
subplot(111)	% reset plot window
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%