function Kv = vgain(system)
%VGAIN  Kv = vgain(system) 
%       Computes the velocity error constant Kv given the 
%       transfer function of a system.
%Inputs: system - lti object
%Output: Kv     - velocity error constant
%
%       See also DCGAIN

%%%%%%%%%%%%%%%%%%%%%% vgain.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB 
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, Jan 1999
%----------------------------------------------------

[den,num] = tfdata(system,'v');
den = small20(den,eps);
num = small20(num,eps);
len_den = length(den);
len_num = length(num);
if den(len_den) ~= 0
  disp('System is type-0, Kv = 0')
  Kv = 0;
 else
  disp('System type is greater than or equal to 1')
  Kv = num(len_num)/den(len_den-1);
end
return
%%%%%%%%%%%%%%%%%%% end of vgain.m %%%%%%%%%%%%%%%%%%